/////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <WindowsX.H>
#include <CommCtrl.H>
#include <ShellAPI.H>
#include <Stdio.H>
#include <Stdlib.H>

#include "Headers/NSWFL.H"

#include "Resources/Resource.H"

#include "Headers/Definitions.H"

#include "Headers/DeleteObject.H"
#include "Headers/DestroyFile.H"

#include "Headers/PackFiles.H"
#include "Headers/UnPackFiles.H"

#include "Headers/Compress.H"
#include "Headers/Decompress.H"

#include "Headers/BlowFish.H"
#include "Headers/Encode.H"
#include "Headers/Decode.H"

#include "Headers/Functions.H"
#include "Headers/StartProcess.H"

#include "Dialogs/Encrypt.H"
#include "Dialogs/Decrypt.H"
#include "Dialogs/Status.H"

/////////////////////////////////////////////////////////////////////

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevious, LPSTR CommandLine, int CmdShow)
{
    HANDLE xMutex = CreateMutex(0, 0, MutexName);

    MainInstance = hInstance;

    if(CommandLine == NULL)
    {
        MessageBox(NULL, "Input file or folder name is NULL." , TitleCaption, 0 + MB_ICONASTERISK + MB_SYSTEMMODAL);
        ReleaseMutex(xMutex);
        CloseHandle(xMutex);
        return 0;
    }

    if( strlen(CommandLine) > 0)
    {
        ProcessInput(CommandLine);

        _fcloseall(); // Attempt To Close All Open Files... (If Any)
        DeleteFile(PI.TempFile1);
        DeleteFile(PI.TempFile2);

    } else MessageBox(NULL, "No input file or folder name." , TitleCaption, 0 + MB_ICONASTERISK + MB_SYSTEMMODAL);

    ReleaseMutex(xMutex);
    CloseHandle(xMutex);

    return 0;
}

/////////////////////////////////////////////////////////////////////

