/////////////////////////////////////////////////////////////////////

BOOL CALLBACK StatusDialog(HWND xHandle, UINT xMessage, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static HMENU SystemMenu       = NULL;

    DWORD DWORDRegTemp            = 0;

    //--------------------------------------------------------------------------

    if(xMessage == WM_INITDIALOG) // Received A Initilize Dialog Message
    {
        StatusDialog_hWnd = xHandle;

        SystemMenu = GetSystemMenu(StatusDialog_hWnd,FALSE);
        AppendMenu(SystemMenu,MF_SEPARATOR,0,0);
        AppendMenu(SystemMenu,MF_STRING,1000,"Version");
        AppendMenu(SystemMenu,MF_STRING,1001,"About");
        AppendMenu(SystemMenu,MF_SEPARATOR,0,0);
        AppendMenu(SystemMenu,MF_STRING,1002,"www.NetWorkDLS.com");

        SendMessage(StatusDialog_hWnd, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)TitleCaption);
        SendMessage(StatusDialog_hWnd, WM_SETICON, TRUE, (LPARAM)LoadIcon(MainInstance, MAKEINTRESOURCE(MainIcon)) );

        PI.OKCancelButton_hWnd = GetDlgItem(StatusDialog_hWnd,100);
        StatusBar_hWnd         = GetDlgItem(StatusDialog_hWnd,1000);
        PI.StatusText_hWnd     = GetDlgItem(StatusDialog_hWnd,1500);

        Set_Text(PI.StatusText_hWnd,"Please Wait...");

        SetTimer(StatusDialog_hWnd, 0, 10, NULL);

        SetForegroundWindow(StatusDialog_hWnd);
        CenterWindow(StatusDialog_hWnd);

        /* Get TopMost Value From Registry */
        if(Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE,StatDlgKey,"TopMost",DWORDRegTemp))
        {
            if(DWORDRegTemp == 1) // If Window Is Supposed To Be TopMost
            {
                CheckDlgButton(StatusDialog_hWnd, 5000, BST_CHECKED);
                SetWindowPos(StatusDialog_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
            }
        }
        else{ // If Key Not Found Create Key And Value
                CreateRegistryKey(HKEY_LOCAL_MACHINE,StatDlgKey);
                Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, StatDlgKey, "TopMost", 1);
                CheckDlgButton(StatusDialog_hWnd, 5000, BST_CHECKED);
                SetWindowPos(StatusDialog_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
        }

        StartProcess_Thread_Handle = CreateThread(NULL, 0, StartProcess_Thread, (LPVOID)0, 0, &StartProcess_Thread_ID);

        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_COMMAND) // Received A Message
    {
        if(wParam == 5000) // Always On Top (Toggle)
        {
            if(IsDlgButtonChecked(StatusDialog_hWnd, 5000))
            {
                SetWindowPos(StatusDialog_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
                Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, StatDlgKey, "TopMost", 1);
            }
            else{
                SetWindowPos(StatusDialog_hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
                Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE, StatDlgKey, "TopMost", 0);
            }
        }

        if(wParam == 100) //- Okay (Dialog Command)
        {
            if(PI.CompleteFlag == TRUE) // Acting as a ok button
            {
                EndDialog(StatusDialog_hWnd,0);
                DestroyWindow(StatusDialog_hWnd);
                return 0;
            }

            if(PI.CompleteFlag == FALSE) // Acting as a cancel Button
            {
                Set_Text(PI.StatusText_hWnd,"Please Wait... Canceling.");
                EnableWindow(PI.OKCancelButton_hWnd, FALSE);
                PI.CancelFlag = TRUE;
                return 0;
            }

            return 0;
        }

        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_SYSCOMMAND) // Received A System Menu Message
    {
        if(LOWORD(wParam) == 1000) //- Version (SysMenu Command)
        {
            char VersionText[128];
            sprintf(VersionText,"%s, Version %s",TitleCaption,FileVersion);
            MessageBox(StatusDialog_hWnd, VersionText, "Application Version", MB_TASKMODAL);
            return 0;
        }

        if(LOWORD(wParam) == 1001) //- About (SysMenu Command)
        {
            NetLogo(StatusDialog_hWnd);
            return 0;
        }

        if(LOWORD(wParam) == 1002) //- www.NetWorkDLS.com (SysMenu Command)
        {
            ShellExecute(0,"Open","Http://www.NetWorkDLS.com",NULL,NULL,SW_SHOWNORMAL);
            return 0;
        }

        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_CLOSE)  // Received Close Message
    {
        if(PI.CompleteFlag == TRUE) // Acting as a ok button
        {
            EndDialog(StatusDialog_hWnd,0);
            DestroyWindow(StatusDialog_hWnd);
            return 0;
        }

        if(PI.CompleteFlag == FALSE) // Acting as a cancel Button
        {
            Set_Text(PI.StatusText_hWnd,"Please Wait... Canceling.");
            EnableWindow(PI.OKCancelButton_hWnd, FALSE);
            PI.CancelFlag = TRUE;
            return 0;
        }

        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_DESTROY) // Received Destroy Message
    {
//        PostQuitMessage(0);
        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_TIMER)
    {
        /* Update Status Bar */
        if(PI.LastValue != PI.StatusValue)
        {
            PI.LastValue = PI.StatusValue;
            SendMessage(StatusBar_hWnd, PBM_SETPOS, (int) PI.StatusValue, 0);
        }

        /* Update Status Text */
        if(PI.StatusText)
        {
            Set_Text(PI.StatusText_hWnd, PI.StatusText);
            PI.StatusText = NULL;
        }

        return 0;
    }

    //--------------------------------------------------------------------------

    return 0;
}

//////////////////////////////////////////////////////////////////////

