///////////////////////////////////////////////////////////////////////////////////////////

char *GenerateFileName(int Offset)
{
    char *FileName = (char *) calloc(8 + 1, 1);

    srand( GetTickCount() + Offset);

    int LocalLoop = 0;
    int Value = 0;

    BOOL Valid = FALSE;

    while(LocalLoop < 8)
    {
        Valid = TRUE;

        Value = rand() %128;

        if((Value < 65) || (Value > 122)) Valid = FALSE;
        if((Value > 90) && (Value < 97 )) Valid = FALSE;

        if(Valid)
        {
            FileName[LocalLoop] = Value;
            LocalLoop++;
        }
    }

    FileName[9] = '\0';

    return FileName;
}

///////////////////////////////////////////////////////////////////////////////////////////

void Error(char *xMessage)
{
    MessageBox(StatusDialog_hWnd, xMessage, TitleCaption, MB_SYSTEMMODAL);
}

///////////////////////////////////////////////////////////////////////////////////////////

int PreCheckFile(void)
{
    FILE *FileHandle  = NULL;
    char *LocalBuffer = NULL;
    DWORD FileSize    = 0;

    /*
        0: Error Occured
        1: Directory
        2: Encrypted File
        3: Packed, Encrypted Directory
        4: Compressed, Encrypted File
        5: Packed, Compressed, Encrypted Directory
        6: Non-448Delta File (Unencrypted)
    */

    /* Check For File Access */
    if(!FileAccess(PI.GlobalSource, FExist)) // Check Exist
    {
        char ErrorTemp[1024];
        sprintf(ErrorTemp,"PreCheckFile: File does not exist: %s", PI.GlobalSource);
        Error(ErrorTemp);
        return 0;
    }

    if(IsDirectory(PI.GlobalSource)) // If Input Is A Directory
        return 1;

    FileSize = Get_FileSize(PI.GlobalSource);

    if(FileSize == -1)
    {
        char ErrorTemp[1024];
        sprintf(ErrorTemp,"PreCheckFile: File size error. The file \"%s\" has been locked. 448Delta %s cannot open locked files.", PI.GlobalSource ,FileVersion);
        Error(ErrorTemp);
        return 0;
    }

    if(FileSize == 0)
    {
        char ErrorTemp[1024];
        sprintf(ErrorTemp,"448Delta %s requires that single files contain some data.", FileVersion);
        Error(ErrorTemp);
        return 0;
    }

    /* Open Source File */
    if((FileHandle = fopen(PI.GlobalSource,"rb")) == NULL)
    {
        char ErrorTemp[1024];
        sprintf(ErrorTemp,"PreCheckFile: Could not open %s for read.", PI.GlobalSource);
        Error(ErrorTemp);
        return 0;
    }

    LocalBuffer = (char *) calloc(FlagLenght + 1, 1);

    /* Read File Flag ( If Any ) */
    fread(LocalBuffer, sizeof(char), FlagLenght, FileHandle);

    if(strcmp(LocalBuffer, ENCFlag) == 0) // If Encrypted File
    {
        if(FileHandle)  fclose(FileHandle);
        if(LocalBuffer) free(LocalBuffer);
        return 2;
    }

    if(strcmp(LocalBuffer, PACFlag) == 0) // If Packed, Encrypted Directory
    {
        if(FileHandle)  fclose(FileHandle);
        if(LocalBuffer) free(LocalBuffer);
        return 3;
    }

    if(strcmp(LocalBuffer, ENCCompress) == 0) // If Compressed, Encrypted File
    {
        if(FileHandle)  fclose(FileHandle);
        if(LocalBuffer) free(LocalBuffer);
        return 4;
    }

    if(strcmp(LocalBuffer, PACCompress) == 0) // If Packed, Compressed, Encrypted Directory
    {
        if(FileHandle)  fclose(FileHandle);
        if(LocalBuffer) free(LocalBuffer);
        return 5;
    }

    if(FileHandle)  fclose(FileHandle);
    if(LocalBuffer) free(LocalBuffer);

    if(FileSize > MaxFileSize )
    {
        char ErrorTemp[1024];
        sprintf(ErrorTemp,"448Delta %s requires that files be under %d MB", FileVersion, MaxFileSize/1024/1024);
        Error(ErrorTemp);
        return 0;
    }

    return 6; // If Non-448Delta File (Unencrypted)
}

///////////////////////////////////////////////////////////////////////////////////////////

BOOL ProcessInput(char *InputName)
{
    PI.GlobalSource   = InputName;
    PI.PreCheckResult = PreCheckFile();

    /*  (PI.PreCheckResult)
        0: Error Occured
        1: Directory
        2: Encrypted File
        3: Packed, Encrypted Directory
        4: Compressed, Encrypted File
        5: Packed, Compressed, Encrypted Directory
        6: Non-448Delta File (Unencrypted)
    */

    if(PI.PreCheckResult == 0) return FALSE;

    PasswordDialog_Thread_Handle = CreateThread(NULL,0,PasswordDialog_Thread,(LPVOID)0,0,&PasswordDialog_Thread_ID);

    while(1)
    {
        if(PI.CancelFlag)     return FALSE;
        if(PI.ReadyToProcess) break;
        Sleep(1);
    }

    DialogBox(MainInstance, MAKEINTRESOURCE(StatusDialogID), 0, StatusDialog);

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////

DWORD WINAPI PasswordDialog_Thread(LPVOID data)
{
    if(PI.PreCheckResult == 6)
    {
        DWORD FileSize = Get_FileSize(PI.GlobalSource);

        if(FileSize == -1)
        {
            char ErrorTemp[1024];
            sprintf(ErrorTemp,"PasswordDialog_Thread: File size error. The file \"%s\" has been locked. 448Delta %s cannot open locked files.", PI.GlobalSource ,FileVersion);
            Error(ErrorTemp);
            return 0;
        }

        if(FileSize > MaxFileSize)
        {
            char ErrorTemp[1024];
            sprintf(ErrorTemp,"448Delta %s cannot encrypt file larger than %d MB.", FileVersion, MaxFileSize/1024/1024);
            Error(ErrorTemp);
            PI.CancelFlag = TRUE;
            return 0;
         }
    }

    if(PI.PreCheckResult == 1)
    {
        PI.GlobalTarget = (char *) calloc(257, 1);
        sprintf(PI.GlobalTarget,"%s.448Pkg",PI.GlobalSource);

        if( FileAccess(PI.GlobalTarget, FExist) )
        {
            if(MessageBox(StatusDialog_hWnd, "Target file already exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
            {
                PI.CancelFlag = TRUE;
                return 0;
            }
        }

        DialogBox(MainInstance, MAKEINTRESOURCE(EncryptDialogID), 0, EncryptDialog);
        return TRUE;
    }

    if( PI.PreCheckResult <= 5 )
    {
        char Drive[257];
        char Directory[257];
        char FileName[257];

        PI.GlobalTarget = (char *) calloc(257, 1);

        _splitpath(PI.GlobalSource,Drive,Directory,FileName,NULL);
        _makepath (PI.GlobalTarget,Drive,Directory,FileName,NULL);

        if( FileAccess(PI.GlobalTarget, FExist) )
        {
            if(MessageBox(StatusDialog_hWnd, "Target file already exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
            {
                PI.CancelFlag = TRUE;
                return 0;
            }
        }

        DialogBox(MainInstance, MAKEINTRESOURCE(DecryptDialogID), 0, DecryptDialog);
        return TRUE;
    }

    if(PI.PreCheckResult == 6)
    {
        PI.GlobalTarget = (char *) calloc(257, 1);
        sprintf(PI.GlobalTarget,"%s.448",PI.GlobalSource);
        DialogBox(MainInstance, MAKEINTRESOURCE(EncryptDialogID), 0, EncryptDialog);
        return TRUE;
    }

    return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////

BOOL SetPriority(void)
{
    DWORD Priority = 0;
    BOOL HighOrRealTime = FALSE;
    HANDLE CurrentProcessHandle = GetCurrentProcess();
    HANDLE CurrentThreadHandle  = GetCurrentThread();

    DWORD ProcessSET     = 0;
    DWORD ThreadSET      = 0;
    BOOL ThreadBoostSET  = 0;
    BOOL ProcessBoostSET = 0;

    if( PI.UsePriorityOption ) return TRUE;

    if(Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE,PriorityKey,"Process",Priority))
    {
        ProcessSET = Priority;
        if(Priority > 2)HighOrRealTime = TRUE;
    }
    else Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE,PriorityKey,"Process",2);

    Priority = 0;

    if(Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE,PriorityKey,"Thread",Priority))
    {
        ThreadSET = Priority;
        if(Priority > 5)HighOrRealTime = TRUE;
    }
    else Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE,PriorityKey,"Thread",4);

    Priority = 0;

    if(Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE,PriorityKey,"ThreadBoost",Priority))
    {
        if(Priority == 0)ThreadBoostSET = TRUE; //Disable Boost
        if(Priority == 1)ThreadBoostSET = FALSE; //Enable Boost
    }
    else Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE,PriorityKey,"ThreadBoost",1);

    Priority = 0;

    if(Get_DWORDRegistryValue(HKEY_LOCAL_MACHINE,PriorityKey,"ProcessBoost",Priority))
    {
        if(Priority == 0)ProcessBoostSET = TRUE; //Disable Boost
        if(Priority == 1)ProcessBoostSET = FALSE; //Enable Boost
    }
    else Set_DWORDRegistryValue(HKEY_LOCAL_MACHINE,PriorityKey,"ProcessBoost",1);

    if(HighOrRealTime == TRUE)
    {
        if(MessageBox(StatusDialog_hWnd,"448Delta is running in high, realtime or timecritical mode. \r\nThis severly cripples windows performance. \r\nContinue anyway? ",TitleCaption,4+256+MB_ICONQUESTION + MB_SYSTEMMODAL) != 6)
        {
            PI.CancelFlag = TRUE;
            PI.CompleteFlag = TRUE;
            return FALSE;
        }
    }

    SetApplicationPriority(CurrentProcessHandle,CurrentThreadHandle,(short)ProcessSET,(short)ThreadSET,ThreadBoostSET,ProcessBoostSET);

    return TRUE; // No Error... Return TRUE
}

///////////////////////////////////////////////////////////////////////////////////////////

