#include "Package.H"

#ifndef NetWorkDLS_Package_PackFiles_SourceFile
#define NetWorkDLS_Package_PackFiles_SourceFile
////////////////////////////////////////////////////////////////////////////////////////////

int PackFiles(char *SourceDirectory, char *DestinationFile)
{
    char StatusText[257];

    char *Buffer           = NULL;

    FILE *LocalTarget      = NULL;
    FILE *LocalSource      = NULL;

    float xFileCount       = 0;
    float xLocalLoop       = 0;
    int StatusCount        = 0;

    DWORD LocalLoop        = 0;
    DWORD CurrentBuffer    = 0;
    DWORD SourceFileSize   = 0;

    char SourceFileName[1024];

    if(Get_FileNames(SourceDirectory)) // Get Names Of Folders And Dirs
    {
        PI.CancelFlag = TRUE;
        return 1;
    }

    if(Package.FileCount == 0)
    {
        PI.StatusText = "Folder contains no files";
        return 0;
    }

    /* Open Target File For Write */
    if((LocalTarget = fopen(DestinationFile,"wb")) == NULL)
    {
        Error("PackFiles: Could Not open file for write.");
        if(LocalTarget)fclose(LocalTarget);
        return 0;
    }

    //Write Number Of Files (Begin)
    if(Package.FileCount < 100000) fprintf(LocalTarget,"0");
    if(Package.FileCount < 10000) fprintf(LocalTarget,"0");
    if(Package.FileCount < 1000) fprintf(LocalTarget,"0");
    if(Package.FileCount < 100) fprintf(LocalTarget,"0");
    if(Package.FileCount < 10) fprintf(LocalTarget,"0");
    fprintf(LocalTarget,"%d",Package.FileCount);
    //Write Number Of Files (End)
    fprintf(LocalTarget,"|");

    //Write Number Of Folders (Begin)
    if(Package.FolderCount < 100000) fprintf(LocalTarget,"0");
    if(Package.FolderCount < 10000) fprintf(LocalTarget,"0");
    if(Package.FolderCount < 1000) fprintf(LocalTarget,"0");
    if(Package.FolderCount < 100) fprintf(LocalTarget,"0");
    if(Package.FolderCount < 10) fprintf(LocalTarget,"0");
    fprintf(LocalTarget,"%d",Package.FolderCount);
    //Write Number Of Folders (End)
    fprintf(LocalTarget,"|");

    Set_Text(PI.StatusText_hWnd, "Writing File && Folder Info");

    //Write File Name Leingths & Names (Begin)
    LocalLoop = 0;
    while(LocalLoop < Package.FileCount)
    {
        if(strlen(Package.FileNames[LocalLoop]) < 100) fprintf(LocalTarget,"0");
        if(strlen(Package.FileNames[LocalLoop]) < 10) fprintf(LocalTarget,"0");
        fprintf(LocalTarget,"%d",strlen(Package.FileNames[LocalLoop]));
        fprintf(LocalTarget,"%s",Package.FileNames[LocalLoop]);
        LocalLoop++;
    }
    //Write File Name Leingths & Names (End)
    fprintf(LocalTarget,"|");

    //Write Folder Name Leingths & Names (Begin)
    LocalLoop = 0;
    while(LocalLoop < Package.FolderCount)
    {
        if(strlen(Package.FolderNames[LocalLoop]) < 100) fprintf(LocalTarget,"0");
        if(strlen(Package.FolderNames[LocalLoop]) < 10) fprintf(LocalTarget,"0");
        fprintf(LocalTarget,"%d",strlen(Package.FolderNames[LocalLoop]));
        fprintf(LocalTarget,"%s",Package.FolderNames[LocalLoop]);
        LocalLoop++;
    }
    //Write Folder Name Leingths & Names (End)
    fprintf(LocalTarget,"|");

    sprintf(StatusText,"Packing %d files && %d folders\n",Package.FileCount,Package.FolderCount);
    Set_Text(PI.StatusText_hWnd, StatusText);

    xFileCount = (float)Package.FileCount; // xFileCount Is float Used For ProgressBar

    //Write File Size & Data (Begin)
    LocalLoop = 0;
    while(LocalLoop < Package.FileCount)
    {
        sprintf(SourceFileName,"%s\\%s",SourceDirectory,Package.FileNames[LocalLoop]);

        SourceFileSize = Get_FileSize(SourceFileName);
        if(SourceFileSize == -1)
        {
            char ErrorTemp[1024];
            sprintf(ErrorTemp,"PackFiles: File size error. The file \"%s\" has been locked. 448Delta cannot open locked files.", SourceFileName );
            Error(ErrorTemp);
            return 0;
        }

        if(SourceFileSize > MaxFileSize)
        {
            char StatusTemp[257];
            sprintf(StatusTemp,"448Delta cannot pack files larger than %d MB each.",MaxFileSize/1024/1024);
            MessageBox(StatusDialog_hWnd, StatusTemp ,TitleCaption,0 + MB_SYSTEMMODAL);
            return 0;
        }

        /* Write File Size */
        if(SourceFileSize < 100000000) fprintf(LocalTarget,"0");
        if(SourceFileSize < 10000000) fprintf(LocalTarget,"0");
        if(SourceFileSize < 1000000) fprintf(LocalTarget,"0");
        if(SourceFileSize < 100000) fprintf(LocalTarget,"0");
        if(SourceFileSize < 10000) fprintf(LocalTarget,"0");
        if(SourceFileSize < 1000) fprintf(LocalTarget,"0");
        if(SourceFileSize < 100) fprintf(LocalTarget,"0");
        if(SourceFileSize < 10) fprintf(LocalTarget,"0");
        fprintf(LocalTarget,"%d",SourceFileSize);

        /* Open Target File */
        if((LocalSource = fopen(SourceFileName,"rb")) == NULL)
        {
            Error("PackFiles: Could not open file for read.");
            if(LocalSource)fclose(LocalSource);
            if(LocalTarget)fclose(LocalTarget);
            return 0;
        }

        /* Write File Data */
        do
        {
            Buffer = (char *) calloc(BufferSize+1,1);
            CurrentBuffer = fread(Buffer,sizeof(char),BufferSize,LocalSource);
            fwrite(Buffer,sizeof(char),CurrentBuffer,LocalTarget);
            free(Buffer);
            Buffer = NULL;
            if(PI.SaveCPUOption) Sleep(1);
        }
        while(CurrentBuffer == BufferSize);

        if(PI.CancelFlag == TRUE)
        {
            if(LocalSource)fclose(LocalSource);
            if(LocalTarget)fclose(LocalTarget);
            return 1;
        }

        LocalLoop++;

        StatusCount++;
        if(StatusCount == 5)
        {
            xLocalLoop = (float)LocalLoop;
            PI.StatusValue = ((xLocalLoop / xFileCount) * 100);
            StatusCount = 0;
        }

        if(LocalSource)fclose(LocalSource);
    }
    //Write File Size & Data (End)

    FreeMemory();

    if(LocalSource)fclose(LocalSource);
    if(LocalTarget)fclose(LocalTarget);

    Sleep(25);
    SendMessage(StatusBar_hWnd, PBM_SETPOS, 100, 0);

    return 1 ;
}

///////////////////////////////////////////////////////////////////////

int Get_FileNames(char *xInputDir)
{
    WIN32_FIND_DATA FindData;
    HANDLE FileHandle;

    int StatCount    = 0;
    int Found        = 0;
    int NeededMemory = 0;

    DWORD LocalLoop = 0;

    char DirTemp[257];
    char StatusText[257];

    sprintf(DirTemp,"%s\\%s",xInputDir,"*.*");
    FileHandle = FindFirstFile(DirTemp,&FindData);
    Found = (int) FileHandle;

    while (Found != 0)
    {
        if( strcmp(FindData.cFileName,".") && strcmp(FindData.cFileName,"..") ) // If (Not) NULL Or Root
        {
            /* If Found Data Is A Directory */
            if(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
            {
                NeededMemory = strlen(FindData.cFileName) + 10;
                Package.FolderNames[Package.FolderCount] = (char *) calloc(NeededMemory,1);
                sprintf(Package.FolderNames[Package.FolderCount],"%s",FindData.cFileName);
                Package.FolderCount++;
            }
            else{   /* If Found Data Is A File */
                NeededMemory = strlen(FindData.cFileName) + 10;
                Package.FileNames[Package.FileCount] = (char *) calloc(NeededMemory,1);
                sprintf(Package.FileNames[Package.FileCount],"%s",FindData.cFileName);
                Package.FileCount++;
            }
            if(PI.SaveCPUOption) Sleep(1);
        }

        if(PI.CancelFlag == TRUE) return 0;

        if(Package.FileCount > MaxFiles || Package.FolderCount > MaxFiles)
        {
            char StatusTemp[257];
            FindClose(FileHandle);
            sprintf(StatusTemp,"448Delta can pack a max of %d files and folders",MaxFiles);
            MessageBox(StatusDialog_hWnd, StatusTemp ,TitleCaption,0 + MB_SYSTEMMODAL);
            return 1;
        }

        Found = FindNextFile(FileHandle, &FindData);

        if(StatCount == 50)
        {
            sprintf(StatusText,"Counting %d files && %d folders.",Package.FileCount,Package.FolderCount);
            Set_Text(PI.StatusText_hWnd, StatusText);
            StatCount = 0;
        }
        StatCount++;
    }

    FindClose(FileHandle);

    if(Package.FolderCount != 0) // If AtLeast One Folder Was Found
    {
        LocalLoop = 0;
        while(LocalLoop < Package.FolderCount)
        {
            if(Get_SubFileNames(xInputDir,Package.FolderNames[LocalLoop]))
            {
                return 1;
            }
            LocalLoop++;
        }
    }

    return 0;
}

//////////////////////////////////////////////////////////////////////

int Get_SubFileNames(char *xInputDir, char *xSubDir)
{
    WIN32_FIND_DATA FindData;
    HANDLE FileHandle;

    int Found        = 0;
    int StatCount    = 0;
    int NeededMemory = 0;

    char DirTemp[257];
    char StatusText[257];

    BOOL FoundDir = FALSE;

    sprintf(DirTemp,"%s\\%s\\%s",xInputDir,xSubDir,"*.*");
    FileHandle = FindFirstFile(DirTemp,&FindData);
    Found = (int) FileHandle;

    while (Found != 0)
    {
        /* If Found Data Is A Directory */
        if( strcmp(FindData.cFileName,".") && strcmp(FindData.cFileName,"..") ) // If (Not) NULL Or Root
        {
            if(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
            {
                NeededMemory = strlen(xSubDir) + strlen(FindData.cFileName) + 10;
                Package.FolderNames[Package.FolderCount] = (char *) calloc(NeededMemory,1);
                sprintf(Package.FolderNames[Package.FolderCount],"%s\\%s",xSubDir,FindData.cFileName);
                FoundDir = TRUE;
                Package.FolderCount++;
            }
            else{ /* If Found Data Is A File */
                 NeededMemory = strlen(xSubDir) + strlen(FindData.cFileName) + 10;
                Package.FileNames[Package.FileCount] = (char *) calloc(NeededMemory,1);
                sprintf(Package.FileNames[Package.FileCount],"%s\\%s",xSubDir,FindData.cFileName);
                Package.FileCount++;
            }
            if(PI.SaveCPUOption) Sleep(1);
        }

        if(PI.CancelFlag == TRUE) return 0;

        if(Package.FileCount > MaxFiles || Package.FolderCount > MaxFiles)
        {
            char StatusTemp[257];
            FindClose(FileHandle);
            sprintf(StatusTemp,"448Delta can pack a max of %d files and folders",MaxFiles);
            MessageBox(StatusDialog_hWnd, StatusTemp ,TitleCaption,0 + MB_SYSTEMMODAL);
            return 1;
        }

        Found = FindNextFile(FileHandle, &FindData);

        if(StatCount == 50)
        {
            sprintf(StatusText,"Counting %d Files && %d Folders.",Package.FileCount,Package.FolderCount);
            Set_Text(PI.StatusText_hWnd, StatusText);
            StatCount = 0;
        }
        StatCount++;
    }

    FindClose(FileHandle);

    return 0;
}

////////////////////////////////////////////////////////////////////////////////////////////
#endif

